'run for instructions



'*****NOTE****: when I transferred this program to a faster computer, I had
'               to disable some of the sounds it made because it would cause
'               freeze-ups (the program would loop before it was finished
'               playing a sound).  If you have this problem you should
'               disable the sounds.  Scan down the program for *NOTES* on
'               where and how to do this.
        

  SCREEN 12
  PLAY "t255"

PRINT "'BOB' ORBITER"
PRINT "in which you pilot your orbiter around and about 2 planetary masses"
PRINT
PRINT "CONTROLS:"
PRINT "     '2','4','6', & '8': down, left, right, and up thrusters, respectively"
PRINT "      '+': increases thrust magnitude, shown in lower left corner of screen"
PRINT "      '-': decreases thrust magnitude.  100 is usually adequate for leaving"
PRINT "           planet surface.  10-ish is good for small orbital variations. "
PRINT "           1000 or so is useful for a quick death."
PRINT "      '7': activates braking sail, indicated by a circle around orbiter"
PRINT "      '9': deactivates braking sail.  Sail reduces speed relative to 'absolute'"
PRINT "           space (by catching space dust).  Also collects fuel.  Fuel collection"
PRINT "           rate is proportional to speed."
PRINT "      '1': activates thruster lock, indicated by a dot in the center of orbiter"
PRINT "      '3': deactivates thruster lock.  While thruster lock is on, whenever you"
PRINT "           hit a thruster key, thruster will fire continuously until a non-"
PRINT "           thruster key is hit.  This was more useful on my 286, which was"
PRINT "           rather inefficient at recognizing keystrokes.  On a faster computer "
PRINT "           it's a good way to waste fuel."
PRINT "      '5': activates the patented LAGRANGIATOR, indicated by a circle in"
PRINT "           the center of the orbiter           "
PRINT "      '=': deactivates LAGRANGIATOR.  While LAGRANGIATOR is on, orbiter auto-"
PRINT "           matically seeks out one of the Lagrange points of the system.  These"
PRINT "           are equilibrium orbit points in a two-mass system."
PRINT "      space bar: ends program"

  RANDOMIZE 523
  DO WHILE INKEY$ = "": ranp = RND: LOOP
 
CLS

PRINT "DISPLAYS:"

PRINT "      upper left corner: distances to planet and moon in pixels"
PRINT "      upper right corner: speed relative to planet and moon.  If speed"
PRINT "                          exceeds 9 while orbiter is in contact with planet"
PRINT "                          or moon, orbiter explodes."
PRINT "      lower left corner, top: Lagrange factor.  The closer this number is "
PRINT "                              to one, the nearer you are to a Lagrange point."
PRINT "      lower left corner, bottom: thruster magnitude"
PRINT "      lower right corner: fuel"
PRINT "      also lower right corner: location of orbiter, planet, and moon, if "
PRINT "                               within two screens in any direction"
PRINT "      screen edges: direction of planet and moon relative to screen center"
PRINT
PRINT "OBJECT OF GAME: none"
PRINT
PRINT "NOTES:"
PRINT "      Fuel capacity is 200.  There are two ways to get fuel: using the braking "
PRINT "  sail and landing on planet or moon.  Only a certain amount of fuel can be"
PRINT "  drawn each time you land.  LAGRANGIATOR seeks one of the two Lagrange points"
PRINT "  that form an equilateral triangle with the two planets.  The nearer you are"
PRINT "  to one of these points when you activate LAGRANGIATOR, the less fuel it will"
PRINT "  consume.  Lagrange points are unstable: if you deactivate LAGRANGIATOR you "
PRINT "  will eventually drift away from Lagrange point.  LAGRANGIATOR does not work"
PRINT "  as well when planet and moon are close to each other."
PRINT ""
PRINT "  See program for notes on varying program parameters."
PRINT "  "
 
  DO WHILE INKEY$ = "": ranp = RND: LOOP

CLS

OPEN "boblur" FOR INPUT AS #1
xbs = 303: ybs = 213
CIRCLE (320, 240), 29, 13
PAINT (320, 240), 13, 13
row = ybs
DO
 INPUT #1, i
 xl = xbs
 DO
  IF i > 4 THEN LINE (xl, row)-STEP(0, 0), 1
  INPUT #1, i
  xl = xl + 1
 LOOP UNTIL i < 0
 row = row + 1
LOOP UNTIL (EOF(1))
CLOSE
DIM Box%(1 TO 2000)
GET (320 - 30, 240 - 30)-STEP(60, 60), Box%



  x1 = 320
  y1 = 240
  dst = .0005
  thr = 1.4
  fuel = 200
  scl = 20

rp1 = 60 * (1 + (RND - .5) / 50 * 33)
rp2 = 120 * (1 + (RND - .5) / 50 * 33)
gm1 = rp1 ^ 3 / 300 * (1 + (RND - .5) / 50 * 25)
gm2 = rp2 ^ 3 / 300 * (1 + (RND - .5) / 50 * 25)
IF RND < .1 THEN gm1 = gm1 * 10
posrng = 1500
xp1 = (RND - .5) * posrng + 320
yp1 = (RND - .5) * posrng + 240
xp2 = (RND - .5) * posrng + 320
yp2 = (RND - .5) * posrng + 240

rp = SQR((xp1 - xp2) ^ 2 + (yp1 - yp2) ^ 2)
vden = SQR(gm1 + gm2) * rp ^ 1.5

vpx1 = gm2 * (yp1 - yp2) / vden * (1 + (RND - .5) / 50 * 0)
vpy1 = gm2 * (xp2 - xp1) / vden * (1 + (RND - .5) / 50 * 0)
vpx2 = gm1 * (yp2 - yp1) / vden * (1 + (RND - .5) / 50 * 0)
vpy2 = gm1 * (xp1 - xp2) / vden * (1 + (RND - .5) / 50 * 0)

ncrat = INT(RND ^ 2.5 * 10)
FOR c = 1 TO ncrat
        rc(c) = SQR(RND) * rp1
        sc(c) = RND ^ 1.5 * .4 * rp1
        IF sc(c) > rp1 - rc(c) THEN sc(c) = RND * (rp1 - rc(c))
        thc(c) = RND * 2 * 3.1416
        xc(c) = rc(c) * COS(thc(c))
        yc(c) = rc(c) * SIN(thc(c))
NEXT c

lalt = 1

  DO

        pn1 = 0: pn2 = 0

        LINE (640 * (1 - 3 / scl), 480 * (1 - 3 / scl))-STEP(0, 0), 10
        LINE (640 * (1 - 2 / scl), 480 * (1 - 3 / scl))-STEP(0, 0), 10
        LINE (640 * (1 - 3 / scl), 480 * (1 - 2 / scl))-STEP(0, 0), 10
        LINE (640 * (1 - 2 / scl), 480 * (1 - 2 / scl))-STEP(0, 0), 10
        IF xp1 > -1280 AND yp1 > -480 THEN CIRCLE (xp1 / scl + 640 * (1 - 3 / scl), yp1 / scl + 480 * (1 - 3 / scl)), rp1 / scl, 4
        IF xp2 > -1280 AND yp2 > -480 THEN CIRCLE (xp2 / scl + 640 * (1 - 3 / scl), yp2 / scl + 480 * (1 - 3 / scl)), rp2 / scl, 4
        CIRCLE (x1 / scl + 640 * (1 - 3 / scl), y1 / scl + 480 * (1 - 3 / scl)), 30 / scl, 9

        CIRCLE (xlst1, ylst1), 32, 8
        PAINT (xlst1, ylst1), 0, 8
        CIRCLE (xlst1, ylst1), 32, 0


        PUT (x1 - 30, y1 - 30), Box%
        IF brk = 1 THEN CIRCLE (x1, y1), 35
        IF lagr = 1 THEN CIRCLE (x1, y1), 5
        IF lk = 1 THEN LINE (x1, y1)-(x1, y1)
        IF ABS(xp1 - 320) < rp1 + 320 AND ABS(yp1 - 240) < rp1 + 240 THEN CIRCLE (xp1, yp1), rp1, 7: pn1 = 1: PAINT (xp1, yp1), 7, 7: FOR c = 1 TO ncrat: CIRCLE (xp1 + xc(c), yp1 + yc(c)), sc(c), 8: PAINT STEP(0, 0), 8, 8: NEXT c
        
        IF ABS(xp2 - 320) < rp2 + 320 AND ABS(yp2 - 240) < rp2 + 240 THEN CIRCLE (xp2, yp2), rp2, 3: pn2 = 1: PAINT (xp2, yp2), 3, 3
        dtp1 = (SQR((x1 - xp1) ^ 2 + (y1 - yp1) ^ 2))
        dtp2 = (SQR((x1 - xp2) ^ 2 + (y1 - yp2) ^ 2))
        dtpc1 = SQR((320 - xp1) ^ 2 + (240 - yp1) ^ 2)
        dtpc2 = SQR((320 - xp2) ^ 2 + (240 - yp2) ^ 2)

        ypr1 = yp1 - 240: xpr1 = 3 / 4 * (xp1 - 320): ra1 = 280 * rp1 / dtpc1
        IF pn1 = 0 AND ypr1 > xpr1 AND ypr1 > -xpr1 THEN LINE (320 * (1 + xpr1 / ypr1) - ra1, 479)-STEP(2 * ra1, 0)
        IF pn1 = 0 AND ypr1 > xpr1 AND ypr1 < -xpr1 THEN LINE (0, 240 * (1 - ypr1 / xpr1) - ra1)-STEP(0, 2 * ra1)
        IF pn1 = 0 AND ypr1 < xpr1 AND ypr1 > -xpr1 THEN LINE (639, 240 * (1 + ypr1 / xpr1) - ra1)-STEP(0, 2 * ra1)
        IF pn1 = 0 AND ypr1 < xpr1 AND ypr1 < -xpr1 THEN LINE (320 * (1 - xpr1 / ypr1) - ra1, 0)-STEP(2 * ra1, 0)
       
        ypr2 = yp2 - 240: xpr2 = 3 / 4 * (xp2 - 320): ra2 = 280 * rp2 / dtpc2
        IF pn2 = 0 AND ypr2 > xpr2 AND ypr2 > -xpr2 THEN LINE (320 * (1 + xpr2 / ypr2) - ra2, 479)-STEP(2 * ra2, 0), 11
        IF pn2 = 0 AND ypr2 > xpr2 AND ypr2 < -xpr2 THEN LINE (0, 240 * (1 - ypr2 / xpr2) - ra2)-STEP(0, 2 * ra2), 11
        IF pn2 = 0 AND ypr2 < xpr2 AND ypr2 > -xpr2 THEN LINE (639, 240 * (1 + ypr2 / xpr2) - ra2)-STEP(0, 2 * ra2), 11
        IF pn2 = 0 AND ypr2 < xpr2 AND ypr2 < -xpr2 THEN LINE (320 * (1 - xpr2 / ypr2) - ra2, 0)-STEP(2 * ra2, 0), 11

        dpsp = (xp2 - xp1) ^ 2 + (yp2 - yp1) ^ 2
        oms = (gm1 + gm2) / dpsp ^ 1.5
        xlc = (gm1 * xp1 + gm2 * xp2) / (gm1 + gm2)
        ylc = (gm1 * yp1 + gm2 * yp2) / (gm1 + gm2)
        fxlc = (x1 - xlc) * oms
        fylc = (y1 - ylc) * oms
        fxl1 = (xp1 - x1) / dtp1 ^ 3 * gm1
        fyl1 = (yp1 - y1) / dtp1 ^ 3 * gm1
        fxl2 = (xp2 - x1) / dtp2 ^ 3 * gm2
        fyl2 = (yp2 - y1) / dtp2 ^ 3 * gm2
        fxlt = fxl1 + fxl2 + fxlc
        fylt = fyl1 + fyl2 + fylc
        vxlc = (y1 - ylc) * SQR(oms)
        vylc = (xlc - x1) * SQR(oms)
        LOCATE 27, 1: PRINT 1 - SQR(fxlt ^ 2 + fylt ^ 2)

        dtp1 = INT(dtp1)
        LOCATE 2, 1: PRINT dtp1

'***NOTE***: delete the next two lines and the two other IF lines
'            further down to disable sounds.  Look for two similar
'            *NOTES* further down

        IF INT(dtp1 / 100) <> INT(lstdtp1 / 100) THEN PLAY "o4l64g"
        IF INT(dtp1 / 1000) <> INT(lstdtp1 / 1000) THEN PLAY "<g>g"
        lstdtp1 = dtp1

        dtp2 = INT(dtp2)
        LOCATE 1, 1: PRINT dtp2
        IF INT(dtp2 / 100) <> INT(lstdtp2 / 100) THEN PLAY "o4l64g"
        IF INT(dtp2 / 1000) <> INT(lstdtp2 / 1000) THEN PLAY "<g>g"
        lstdtp2 = dtp2


        klk$ = kbd$
        kbd$ = INKEY$
        IF kbd$ = "=" THEN lagr = -1: thr = 1.4

        IF lk = 1 AND kbd$ = "" AND (klk$ = "8" OR klk$ = "4" OR klk$ = "2" OR klk$ = "6") THEN kbd$ = klk$
       
        lalt = lalt + 1: IF lalt > 2 THEN lalt = 1

       
        IF lagr = 1 THEN
                thrx = 10000 * fxlt + vx - vxlc
                thr = ABS(thrx): IF thr > 1 THEN thr = 1

                IF thrx > 0 AND fuel > thr THEN vx = vx - thr: fuel = fuel - thr: LINE (x1 + 30, y1)-STEP(thr * 2, 0), 14
                IF thrx < 0 AND fuel > thr THEN vx = vx + thr: fuel = fuel - thr: LINE (x1 - 30, y1)-STEP(-thr * 2, 0), 14
        
                thry = 10000 * fylt + vy - vylc
                thr = ABS(thry): IF thr > 1 THEN thr = 1
       
                IF thry > 0 AND fuel > thr THEN vy = vy - thr: fuel = fuel - thr: LINE (x1, y1 + 30)-STEP(0, thr * 2), 14
                IF thry < 0 AND fuel > thr THEN vy = vy + thr: fuel = fuel - thr: LINE (x1, y1 - 30)-STEP(0, -thr * 2), 14

        END IF

        SELECT CASE kbd$
                CASE "8": IF fuel > thr THEN vy = vy - thr: fuel = fuel - thr: LINE (x1, y1 + 30)-STEP(0, thr * 2), 14
                CASE "6": IF fuel > thr THEN vx = vx + thr: fuel = fuel - thr: LINE (x1 - 30, y1)-STEP(-thr * 2, 0), 14
                CASE "2": IF fuel > thr THEN vy = vy + thr: fuel = fuel - thr: LINE (x1, y1 - 30)-STEP(0, -thr * 2), 14
                CASE "4": IF fuel > thr THEN vx = vx - thr: fuel = fuel - thr: LINE (x1 + 30, y1)-STEP(thr * 2, 0), 14
                CASE "9": brk = -1
                CASE "7": brk = 1
                CASE "1": lk = 1
                CASE "3": lk = -1
                CASE "+": thr = 5 / 4 * thr
                CASE "-": thr = 4 / 5 * thr
                CASE "5": lagr = 1
                
        END SELECT
        LOCATE 28, 1: PRINT INT(100 * thr / 1.4)
        LOCATE 28, 74: PRINT INT(fuel)
        IF z = 7 THEN CLS : z = 0
        z = z + 1
        xp1 = xp1 + vpx1
        yp1 = yp1 + vpy1
        xp2 = xp2 + vpx2
        yp2 = yp2 + vpy2
        x1 = x1 + vx
        y1 = y1 + vy

        xlst1 = x1: ylst1 = y1
       
        DO WHILE x1 > 640 - 31: x1 = x1 - 640 + 62: xp1 = xp1 - 640 + 62: xp2 = xp2 - 640 + 62: LOOP
        DO WHILE y1 > 480 - 31: y1 = y1 - 480 + 62: yp1 = yp1 - 480 + 62: yp2 = yp2 - 480 + 62: LOOP
        DO WHILE x1 < 31: x1 = x1 + 640 - 62: xp1 = xp1 + 640 - 62: xp2 = xp2 + 640 - 62: LOOP
        DO WHILE y1 < 31: y1 = y1 + 480 - 62: yp1 = yp1 + 480 - 62: yp2 = yp2 + 480 - 62: LOOP
        dps1 = (xp1 - x1) ^ 2 + (yp1 - y1) ^ 2
        vmag1 = (vx - vpx1) ^ 2 + (vy - vpy1) ^ 2
        LOCATE 2, 74: PRINT INT(SQR(vmag1) * 10) / 10
        dps2 = (xp2 - x1) ^ 2 + (yp2 - y1) ^ 2
        vmag2 = (vx - vpx2) ^ 2 + (vy - vpy2) ^ 2
        LOCATE 1, 74: PRINT INT(SQR(vmag2) * 10) / 10


        SELECT CASE dps1
                CASE IS > (rp1 + 30) ^ 2
                 gd = 1 / dps1 ^ 1.5
                 vx = vx + gm1 * (xp1 - x1) * gd
                 vy = vy + gm1 * (yp1 - y1) * gd
                 
                CASE ELSE
                 IF vmag1 > 81 THEN ph = RND: FOR i = 1 TO vmag1 / 2 - (SGN(vmag1 / 2 - 1000) + 1) / 2 * (vmag1 / 2 - 1000): ex = SIN(.07 * i + ph) + SQR(2): CIRCLE (x1, y1), i, , , , ex: NEXT i: PLAY "o0l8ccccc": FOR p = 1 TO 1000: NEXT p: END
                
'***NOTE***:  delete next line to disable sound

                 IF vmag1 > 16 THEN PLAY "o0l12c+d"
                 vx = vx - 2 * ((xp1 - x1) * (vx - vpx1) + (yp1 - y1) * (vy - vpy1)) * (xp1 - x1) / (rp1 + 32) ^ 2
                 vy = vy - 2 * ((xp1 - x1) * (vx - vpx1) + (yp1 - y1) * (vy - vpy1)) * (yp1 - y1) / (rp1 + 32) ^ 2
                 vx = (1 - 200 * dst) * (vx - vpx1) + vpx1
                 vy = (1 - 200 * dst) * (vy - vpy1) + vpy1
                 IF lfs1 > 0 THEN fuel = fuel + .1
                 lfs1 = lfs1 - .1
                 onp = 1
                
        END SELECT

        SELECT CASE dps2
                CASE IS > (rp2 + 30) ^ 2
                 gd = 1 / dps2 ^ 1.5
                 vx = vx + gm2 * (xp2 - x1) * gd
                 vy = vy + gm2 * (yp2 - y1) * gd
                
                CASE ELSE
                 IF vmag2 > 81 THEN ph = RND: FOR i = 1 TO vmag2 / 2 - (SGN(vmag2 / 2 - 1000) + 1) / 2 * (vmag2 / 2 - 1000): ex = SIN(.07 * i + ph) + SQR(2): CIRCLE (x1, y1), i, , , , ex: NEXT i: PLAY "o0l8ccccc": FOR p = 1 TO 1000: NEXT p: END
                
'***NOTE***: delete next line to disable sound              
                
                 IF vmag2 > 16 THEN PLAY "o0l12c+d"
                 vx = vx - 2 * ((xp2 - x1) * (vx - vpx2) + (yp2 - y1) * (vy - vpy2)) * (xp2 - x1) / (rp2 + 32) ^ 2
                 vy = vy - 2 * ((xp2 - x1) * (vx - vpx2) + (yp2 - y1) * (vy - vpy2)) * (yp2 - y1) / (rp2 + 32) ^ 2
                 vx = (1 - 200 * dst) * (vx - vpx2) + vpx2
                 vy = (1 - 200 * dst) * (vy - vpy2) + vpy2
                 IF lfs2 > 0 THEN fuel = fuel + .1
                 lfs2 = lfs2 - .1
                 onp = 1
               
        END SELECT

        dpsp = (xp2 - xp1) ^ 2 + (yp2 - yp1) ^ 2
               
        gd = 1 / dpsp ^ 1.5
        vpx1 = vpx1 + gm2 * (xp2 - xp1) * gd
        vpy1 = vpy1 + gm2 * (yp2 - yp1) * gd
        vpx2 = vpx2 + gm1 * (xp1 - xp2) * gd
        vpy2 = vpy2 + gm1 * (yp1 - yp2) * gd



        onp = 0
        IF SQR(dps1) < rp1 + 40 OR SQR(dps2) < rp2 + 40 THEN onp = 1
        IF onp = 0 THEN lfs1 = RND * 38 - 10: lfs2 = RND * 76 - 20
        vx = (1 - 0! * dst) * vx
        vy = (1 - 0! * dst) * vy
        IF brk = 1 THEN vx = (1 - 40 * dst) * vx: vy = (1 - 40 * dst) * vy
        vabs = SQR(vx ^ 2 + vy ^ 2)
        IF brk = 1 AND onp <> 1 THEN fuel = fuel + vabs / 50
        IF fuel > 200 THEN fuel = 200


LOOP UNTIL INKEY$ = " "




                      
                                              

          







